config/routes.rb
# frozen_string_literal: true
Railsgoat::Application.routes.draw do

  get "login" => "sessions#new"
  get "signup" => "users#new"
  get "logout" => "sessions#destroy"

  get "forgot_password" => "password_resets#forgot_password"
  post "forgot_password" => "password_resets#send_forgot_password"
  get "password_resets" => "password_resets#confirm_token"
  post "password_resets" => "password_resets#reset_password"

  get "dashboard/doc" => "dashboard#doc"

  resources :sessions

  resources :users do
    get "account_settings"

    resources :retirement
    resources :paid_time_off
    resources :work_info
    resources :performance
    resources :benefit_forms
    resources :messages

    resources :pay do
      collection do
        post "update_dd_info"
        post "decrypted_bank_acct_num"
      end
    end

  end

  get "download" => "benefit_forms#download"
  post "upload" => "benefit_forms#upload"

  resources :tutorials do
    collection do
      get "credentials"
    end
  end

  resources :schedule do
    collection do
      get "get_pto_schedule"
    end
  end

  resources :admin do
    get "dashboard"
    get "get_user"
    post "delete_user"
    patch "update_user"
    get "get_all_users"
    get "analytics"
  end

  resources :dashboard do
    collection do
      get "home"
      get "change_graph"
    end
  end

  namespace :api, defaults: {format: "json"} do
    namespace :v1 do
      resources :users
      resources :mobile
    end
  end

  root to: "sessions#new"
end

app/models/analytics.rb
# frozen_string_literal: true
class Analytics < ApplicationRecord
  scope :hits_by_ip, ->(ip, col = "*") { select("#{col}").where(ip_address: ip).order("id DESC") }

  def self.count_by_col(col)
    calculate(:count, col)
  end

  def self.parse_field(field)
    valid_fields = ["ip_address", "referrer", "user_agent"]

    if valid_fields.include?(field)
      field
    else
      "1"
    end
  end
end

app/models/benefits.rb
# frozen_string_literal: true
class Benefits < ApplicationRecord

  def self.save(file, backup = false)
    data_path = Rails.root.join("public", "data")
    full_file_name = "#{data_path}/#{file.original_filename}"
    f = File.open(full_file_name, "wb+")
    f.write file.read
    f.close
    make_backup(file, data_path, full_file_name) if backup == "true"
  end

  def self.make_backup(file, data_path, full_file_name)
    if File.exist?(full_file_name)
      silence_streams(STDERR) { system("cp #{full_file_name} #{data_path}/bak#{Time.zone.now.to_i}_#{file.original_filename}") }
    end
  end

  def self.silence_streams(*streams)
    on_hold = streams.collect { |stream| stream.dup }
    streams.each do |stream|
      stream.reopen(RUBY_PLATFORM =~ /mswin/ ? "NUL:" : "/dev/null")
      stream.sync = true
    end
    yield
  ensure
    streams.each_with_index do |stream, i|
      stream.reopen(on_hold[i])
    end
  end
end

app/models/key_management.rb
# frozen_string_literal: true
class KeyManagement < ApplicationRecord
  belongs_to :work_info
  belongs_to :user
end

app/models/message.rb
# frozen_string_literal: true
class Message < ApplicationRecord
  belongs_to :user
  validates_presence_of :creator_id, :receiver_id, :message

  def creator_name
    if creator = User.where(id: self.creator_id).first
      creator.full_name
    else
      "Name unavailable"
    end
  end
end

app/models/paid_time_off.rb
# frozen_string_literal: true
class PaidTimeOff < ApplicationRecord
  belongs_to :user
  has_many :schedule, foreign_key: :user_id, primary_key: :user_id, dependent: :destroy

  def sick_days_remaining
    self.sick_days_earned - self.sick_days_taken
  end

  def pto_days_remaining
    self.pto_earned - self.pto_taken
  end

  def sick_days_taken_percentage
    result = self.sick_days_taken.to_f /  self.sick_days_earned.to_f * 100.0
  end
end

app/models/pay.rb
# frozen_string_literal: true
class Pay < ApplicationRecord
  # Associations
  belongs_to :user

  # Validations
  validates :bank_account_num, presence: true
  validates :bank_routing_num, presence: true
  validates :percent_of_deposit, presence: true

  # callbacks
  before_save :encrypt_bank_account_num

  def as_json
    super(only: [:bank_account_num, :bank_routing_num, :percent_of_deposit, :id])
  end

  def encrypt_bank_account_num
    self.bank_account_num = Encryption.encrypt_sensitive_value(self.bank_account_num)
  end
end

app/models/performance.rb
# frozen_string_literal: true
class Performance < ApplicationRecord
  belongs_to :user

  def reviewer_name
   u = User.find_by_id(self.reviewer)
   u.full_name if u.respond_to?("fullname")
  end
end

app/models/retirement.rb
# frozen_string_literal: true
class Retirement < ApplicationRecord
  belongs_to :user
end

app/models/schedule.rb
# frozen_string_literal: true
class Schedule < ApplicationRecord
  belongs_to :paid_time_off

  validates_presence_of :date_begin, :date_end, :event_desc, :event_name, :event_type
end

app/models/user.rb
# frozen_string_literal: true
require "encryption"

class User < ApplicationRecord
  validates :password, presence: true,
                       confirmation: true,
                       length: {within: 6..40},
                       on: :create,
                       if: :password

  validates_presence_of :email
  validates_uniqueness_of :email
  validates_format_of :email, with: /.+@.+\..+/i

  has_one :retirement, dependent: :destroy
  has_one :paid_time_off, dependent: :destroy
  has_one :work_info, dependent: :destroy
  has_many :performance, dependent: :destroy
  has_many :pay, dependent: :destroy
  has_many :messages, foreign_key: :receiver_id, dependent: :destroy

  before_save :hash_password
  after_create { generate_token(:auth_token) }
  before_create :build_benefits_data

  def build_benefits_data
    build_retirement(POPULATE_RETIREMENTS.sample)
    build_paid_time_off(POPULATE_PAID_TIME_OFF.sample).schedule.build(POPULATE_SCHEDULE.sample)
    build_work_info(POPULATE_WORK_INFO.sample)
    # Uncomment below line to use encrypted SSN(s)
    #work_info.build_key_management(:iv => SecureRandom.hex(32))
    performance.build(POPULATE_PERFORMANCE.sample)
  end

  def full_name
    "#{self.first_name} #{self.last_name}"
  end

  private

  def self.authenticate(email, password)
    auth = nil
    user = find_by_email(email)
    raise "#{email} doesn't exist!" if !(user)
    if user.password == Digest::MD5.hexdigest(password)
      auth = user
    else
      raise "Incorrect Password!"
    end
    return auth
  end

  def hash_password
    if will_save_change_to_password?
      self.password = Digest::MD5.hexdigest(self.password)
    end
  end

  def generate_token(column)
    loop do
      self[column] = Encryption.encrypt_sensitive_value(self.id)
      break unless User.exists?(column => self[column])
    end

    self.save!
  end
end

app/models/work_info.rb
# frozen_string_literal: true
class WorkInfo < ApplicationRecord
  belongs_to :user
  has_one :key_management, foreign_key: :user_id, primary_key: :user_id, dependent: :destroy
  #before_save :encrypt_ssn

  # We should probably use this
  def last_four
    "***-**-" << self.decrypt_ssn[-4, 4]
  end

  def encrypt_ssn
    aes = OpenSSL::Cipher.new(cipher_type)
    aes.encrypt
    aes.key = key[0..31]
    aes.iv = iv if iv != nil
    self.encrypted_ssn = aes.update(self.SSN) + aes.final
    self.SSN = nil
  end

  def decrypt_ssn
    aes = OpenSSL::Cipher.new(cipher_type)
    aes.decrypt
    aes.key = key[0..31]
    aes.iv = iv if iv != nil
    aes.update(self.encrypted_ssn) + aes.final
  end

  def key
    raise "Key Missing" unless KEY.present?
    KEY
  end

  def iv
    raise "No IV for this User" unless self.key_management.try(:iv).present?
    self.key_management.iv
  end

  def cipher_type
    "aes-256-cbc"
  end
end

app/helpers/admin_helper.rb
# frozen_string_literal: true
module AdminHelper
end

app/helpers/dashboard_helper.rb
# frozen_string_literal: true
module DashboardHelper
end

app/helpers/messages_helper.rb
# frozen_string_literal: true
module MessagesHelper
end

app/helpers/pay_helper.rb
# frozen_string_literal: true
module PayHelper
end

app/helpers/schedule_helper.rb
# frozen_string_literal: true
module ScheduleHelper
end

app/helpers/sessions_helper.rb
# frozen_string_literal: true
module SessionsHelper
end

app/helpers/tutorials_helper.rb
# frozen_string_literal: true
module TutorialsHelper
end

app/helpers/users_helper.rb
# frozen_string_literal: true
module UsersHelper
end

app/helpers/work_info_helper.rb
# frozen_string_literal: true
module WorkInfoHelper
end

app/views/admin/analytics.html.erb
<form action="" id="analytics_search">
  Search by IP: <input type="text" id="ip" name="ip"><br />
  <input type="checkbox" value="" id="field_ip_address" name="field[ip_address]"> IP Address<br />
  <input type="checkbox" value="" id="field_referrer" name="field[referrer]"> Referrer<br />
  <input type="checkbox" value="" id="field_user_agent" name="field[user_agent]"> User Agent
</form>

<div id="dt_example" class="example_alt_pagination">
    <table class="table table-striped table-hover table-bordered pull-left <%= "custom" if params[:field] %>" id="data-table">
      <thead>
        <tr>
          <%
          count = (params[:field] ? (custom_fields.count+1) : 6)
          count.times do %>
          <th>&nbsp;</th>
          <% end %>
        </tr>
      </thead>
      <tbody>
       <% @analytics.each do |a|%>
      <tr>
        <% a.attributes.each do |k,v| %>
        <td><%= v %></td>
        <% end %>
        </tr>
     <% end %>
      </tbody>
    </table>
  <div id="editAcct" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel1" aria-hidden="true">
  </div>
    <div class="clearfix">
    </div>
  </div>
</div>

<%= javascript_include_tag "jquery.dataTables.min.js"%>

<script type="text/javascript">

function dataTablePagination(){
  $('#data-table').dataTable({
      "sPaginationType": "full_numbers"
    });
};

$(document).ready(dataTablePagination());
</script>

app/views/admin/dashboard.html.erb
<div class="dashboard-wrapper">
  <div class="main-container">
    <div class="row-fluid">
      <div class="span12">
        <div id="success" style="display: none;" class="alert alert-block alert-success fade in">
          <h4 class="alert-heading">Success!</h4>
          <p>User information successfully updated.</p>
        </div>
      </div>
    </div>

    <div class="row-fluid">
      <div class="span12">
        <div id="failure" style="display: none;" class="alert alert-block alert-error fade in">
          <h4 class="alert-heading">Error!</h4>
          <p>Something went wrong.</p>
        </div>
      </div>
    </div>

    <div class="row-fluid">
      <div class="span12">
        <div class="widget">
          <div class="widget-header">
            <div class="title">
              <span class="fs1" aria-hidden="true" data-icon="&#xe071;"></span>Manage Users
            </div>
          </div>

          <div id="userDataTable" class="widget-body">
          </div> <!-- End widget-body-->
        </div> <!-- End widget header-->
      </div>
    </div>
  </div>
</div>

<%= javascript_include_tag "jquery.dataTables.min.js"%>

<script type="text/javascript">

function makeActive(){
  $('li[id="admin"]').addClass('active');
};

function loadTable(){
  $("#userDataTable").load("/admin/"+ <%= params[:admin_id] %> + "/get_all_users")
};

$(document).ready(
  makeActive,
  loadTable()
);
</script>

app/views/admin/get_all_users.html.erb
<div id="dt_example" class="example_alt_pagination">
    <table class="table table-striped table-hover table-bordered pull-left" id="data-table">
      <thead>
        <tr>
          <th>
            Name
          </th>
          <th>
            Email
          </th>
          <th>
            Admin User
          </th>
          <th>
            Action
          </th>
        </tr>
      </thead>
      <tbody>
       <% @users.each do |u|%>
      <tr>
            <td style="word-wrap:break-word;">
              <%= "#{u.first_name} #{u.last_name}"%>
            </td>
            <td>
              <%= u.email%>
            </td>
            <td>
              <%= u.admin ? %{<span class="fs1" aria-hidden="true" data-icon="&#xe0fe;"}.html_safe : nil %>
            </td>
            <td>
              <%= link_to "Edit", "#", {:onClick => "javascript:openEditModal(#{u.id});", :role => "button", :style => "width:70px", :class => "btn btn-inverse", "data-toggle" => "modal"}%>
            </td>
          </tr>
     <% end %>
      </tbody>
    </table>
  <div id="editAcct" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel1" aria-hidden="true">
  </div>
    <div class="clearfix">
    </div>
  </div>
</div>

<script type="text/javascript">

function openEditModal(id){
 var link = '/admin/'+ id +'/get_user';
 $("#editAcct").load(link);
 $("#editAcct").modal('show');
};

function dataTablePagination(){
  $('#data-table').dataTable({
      "sPaginationType": "full_numbers"
    });
};

$(document).ready(dataTablePagination());
</script>

app/views/admin/get_user.html.erb
<!-- Begin Modal -->
    <div class="modal-header">
      <button type="button" class="close" data-dismiss="modal" aria-hidden="true">
        ×
      </button>
      <h4 id="myModalLabel1">
        Account Settings
      </h4>
    </div>
    <div class="modal-body">
      <div class="row-fluid">
        <div class="span8">
        <%= form_for @user, :html => {:id => "account_edit"} do |f| %>
        <div class="control-group">
      <%= f.label :email, nil, {:class => "control-label"}%>
      <%= f.text_field :email, {:class => "span12"}%>
      </div>

      <div class="control-group">
      <%= f.label :first_name, nil, {:class => "control-label"}%>
      <%= f.text_field :first_name, {:class => "span12"} %>
      </div>

      <div class="control-group">
      <%= f.label :last_name, nil, {:class => "control-label"}%>
      <%= f.text_field :last_name, {:class => "span12"} %>
      </div>

         <div class="control-group">
      <%= f.label :password, nil, {:class => "control-label"}%>
      <%= f.password_field :password, {:class => "span12", :placeholder => "Enter Password"}%>
     </div>

     <div class="control-group">
      <%= f.label :password_confirmation, nil, {:class => "control-label"}%>
      <%= f.password_field :password_confirmation, {:class => "span12", :placeholder => "Enter Password"} %>
     </div>

      <%= f.label :admin, nil, {:class => "control-label"}%>
      <%= f.select(:admin, @admin_select) %>
        </div>
      </div>
      <div class="row-fluid">
      </div>
    </div>
    <div class="modal-footer">
      <button class="btn" data-dismiss="modal" aria-hidden="true">
        Close
      </button>
         <%= link_to "Delete", "#", {:id => "delete_button", :class => "btn btn-danger pull-left"} %>
         <%= f.submit "Submit", {:id => 'submit_button', :class => "btn btn-primary pull-right"} %>
    </div>
       <% end %>
<!-- End Modal -->

<%= javascript_include_tag ('validation.js')%>

<script type="text/javascript">

$('#submit_button').click(function() {
  var valuesToSubmit = $("#account_edit").serialize();
  $("#editAcct").modal('hide');

  $.ajax({
      url: "/admin/" +  <%= @user.id %> + "/update_user.json",
    data: valuesToSubmit,
    type: "POST",
    success: function(response) {
      $('#success').show(500).delay(1500).fadeOut();
    loadTable();
    },
    error: function(event) {
    $('#failure').show(500).delay(1500).fadeOut();
    }
  });

});

$('#delete_button').click(function() {
  $("#editAcct").modal('hide');

  $.ajax({
      url: "/admin/" +  <%= params[:admin_id] %> + "/delete_user.json",
    type: "POST",
    success: function(response) {
      $('#success').show(500).delay(1500).fadeOut();
    loadTable();
    },
    error: function(event) {
    $('#failure').show(500).delay(1500).fadeOut();
    }
  });

});

</script>

app/views/layouts/shared/_footer.html.erb
<footer>
  <p align="center">
    &copy; The Open Web Application Security Project - OWASP, 2015
  </p>
</footer>

 <script type="text/javascript">

 //ScrollUp
  $(function () {
    $.scrollUp({
      scrollName: 'scrollUp', // Element ID
      topDistance: '300', // Distance from top before showing element (px)
      topSpeed: 300, // Speed back to top (ms)
      animation: 'fade', // Fade, slide, none
      animationInSpeed: 400, // Animation in speed (ms)
      animationOutSpeed: 400, // Animation out speed (ms)
      scrollText: 'Scroll to top', // Text for element
      activeOverlay: false, // Set CSS color to display scrollUp active point, e.g '#00FFFF'
    });
  });
</script>

app/views/layouts/shared/_header.html.erb
<% if current_user %>
  <header>
      
      <span style="color:#eee;margin-left:10px;">
        Font Size:
        <a data-no-turbolink='true' href="/dashboard/home?font=8pt" style="font-size:10pt;color:#eee;">A</a>
        <a data-no-turbolink='true' href="/dashboard/home?font=200%25" style="font-size:18pt;color:#eee;">A</a>
      </span>
      
      <div class="user-profile">
        <a data-toggle="dropdown" class="dropdown-toggle">
          <img src=" <%= image_path('profile_color.jpg')%>"  alt="profile">
        </a>
        <span class="caret"></span>
        <ul class="dropdown-menu pull-right">
          <li>
           <%= link_to "Account settings", user_account_settings_path(user_id: current_user.id) %>
          </li>
          <li>
            <%= link_to "Logout", logout_path %>
          </li>
        </ul>
      </div>
      <ul class="mini-nav">
       <li style="color: #FFFFFF">
          <!--
          I'm going to use HTML safe because we had some weird stuff
          going on with funny chars and jquery, plus it says safe so I'm guessing
          nothing bad will happen
          -->
          Welcome, <%= current_user.first_name.html_safe %>
       </li>
      </ul>
      <ul class="mini-nav">
        <li>
          <%= button_to "Visit Tutorial", nil,
          {
           :class => "btn",
           :method => "get",
           :onclick => "window.open('https://github.com/OWASP/railsgoat/wiki', '_blank')"
           }  %>
        </li>
      </ul>
  </header>
<% else %>
  <!-- Want to use this template whether auth'd or not so I've got some code to determine how to render below -->
  <header>
      <ul class="mini-nav">
           <li>
             <%= button_to "Signup", signup_path, {:class => "btn btn-primary", :method => "get"} %>
           </li>
         </ul>
      <ul class="mini-nav">
           <li>
             <%= button_to "login", login_path, {:class => "btn", :method => "get"} %>
           </li>
         </ul>
      <ul class="mini-nav">
           <li>
             <%= button_to "Tutorial Credentials", "#myModalLabel1", {:id => "show_creds_btn", :class => "btn btn-danger", :method => "get"} %>
           </li>
      </ul>
      <ul class="mini-nav">
        <li>
            <%= button_to "Visit Tutorial", nil,
            {
             :class => "btn",
             :method => "get",
             :onclick => "window.open('https://github.com/OWASP/railsgoat/wiki', '_blank')"
             }  %>
        </li>
      </ul>
  </header>

  <div id="modal_div" class="modal hide fade" tabindex="-1" role="dialog" aria-labelledby="myAlert" aria-hidden="true">
  </div>

<script type="text/javascript">

$('#show_creds_btn').click(function(event) {
  event.preventDefault();
  $("#modal_div").load(<%= credentials_tutorials_path.inspect.html_safe %>);
  $("#modal_div").modal("show");
});
</script>

<% end %>

app/views/layouts/shared/_messages.html.erb
<% flash.each do |name, msg| %>
  <% name = name.to_sym %>
  <% if name == :error %>
    <div class="alert alert-error">
      <a class="close" data-dismiss="alert" href="#">×</a>
          <%= content_tag :div, msg, :id => "flash_notice" %>
    </div>
  <% elsif name == :success %>
    <div class="alert alert-success">
      <a class="close" data-dismiss="alert" href="#">×</a>
          <%= content_tag :div, msg, :id => "flash_notice" %>
    </div>
  <% elsif name == :info %>
    <div class="alert alert-info">
      <a class="close" data-dismiss="alert" href="#">×</a>
        <%= content_tag :div, msg, :id => "flash_notice" %>
    </div>
  <% end %>
<% end %>

app/views/layouts/shared/_sidebar.html.erb
<% if current_user %>
    <div id="mainnav" class="hidden-phone hidden-tablet">
      <ul style="display: block;">
        <li id="home">
          <%= link_to home_dashboard_index_path do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe0a0;"></span>
            </div>
            Dashboard
          <% end %>
        </li>
        <% if is_admin? %>
        	<li class="submenu" id='admin'>
        	   <a href="#">
        	    <div class="icon">
        	      <span class="fs1" aria-hidden="true" data-icon="&#xe1c8;"></span>
        	    </div>
        	    Admin
        	   	</a>
				<ul>
            	  <li>
            	    <%= link_to admin_dashboard_path(:admin_id => "1") do %>
		        	    Manage Users
		            <% end %>
            	  </li>
            	  <li>
            	    <%= link_to admin_analytics_path(:admin_id => "1") do %>
		        	    View Analytics
		            <% end %>
            	  </li>
            	</ul>
            </li>
    	<% end %>
        <li id="benefit_forms">
    <%= link_to user_benefit_forms_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe05c;"></span>
            </div>
            Benefit Forms
          <% end %>
        </li>
        <li id="retirement">
           <%= link_to user_retirement_index_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe096;"></span>
            </div>
            401k Info
          <% end %>
        </li>
        <li id="pto">
          <%= link_to user_paid_time_off_index_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe0d2;"></span>
            </div>
            PTO
         <% end %>
        </li>
        <li id="employee_info">
           <%= link_to user_work_info_index_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe0a9;"></span>
            </div>
            Work Info
          <% end %>
        </li>
        <li id="performance">
          <%= link_to user_performance_index_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe14a;"></span>
            </div>
            Performance
          <% end %>
        </li>
        <li id="messages">
          <%= link_to user_messages_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe040;"></span>
            </div>
            Messages
          <% end %>
        </li>
    <li id="pay">
      <%= link_to user_pay_index_path(user_id: current_user.id) do %>
            <div class="icon">
              <span class="fs1" aria-hidden="true" data-icon="&#xe038;"></span>
            </div>
            Pay
          <% end %>
        </li>
      </ul>
    </div>

  <script type="text/javascript">
  //Main menu navigation

  $('.submenu > a').click(function(e){
    e.preventDefault();
    var submenu = $(this).siblings('ul');
    var li = $(this).parents('li');
    var submenus = $('#mainnav li.submenu ul');
    var submenus_parents = $('#mainnav li.submenu');
    if(li.hasClass('open'))
    {
      if(($(window).width() > 768) || ($(window).width() < 479)) {
        submenu.slideUp();
      } else {
        submenu.fadeOut(250);
      }
      li.removeClass('open');
    } else
    {
      if(($(window).width() > 768) || ($(window).width() < 479)) {
        submenus.slideUp();
        submenu.slideDown();
      } else {
        submenus.fadeOut(250);
        submenu.fadeIn(250);
      }
      submenus_parents.removeClass('open');
      li.addClass('open');
    }
  });

  var ul = $('#mainnav > ul');

  $('#mainnav > a').click(function(e)
  {
    e.preventDefault();
    var mainnav = $('#mainnav');
    if(mainnav.hasClass('open'))
    {
      mainnav.removeClass('open');
      ul.slideUp(250);
    } else
    {
      mainnav.addClass('open');
      ul.slideDown(250);
    }
  });

  </script>
<% end %>